﻿<!DOCTYPE html>
<html lang="en-US">
<html>

<head>
<link rel="shortcut icon" href="z.ico">
<title>Week 13 - This is tab text</title>

<style>
body {background-color:rgb(51, 0, 255) ;color: rgb(255, 242, 0)}
h1 {font-family:harrington;font-size:200%;text-align:center;}
h2 {font-family:papyrus;font-size:150%;text-align:center;}
h3 {font-family:papyrus;font-size:125%;}
p {font-family:papyrus;font-size:100%;}
li {font-family:papyrus;font-size:100%;}
a {font-family:papyrus;font-size:100%;}
table,th,td 
{border:1px solid black;
border-collapse:collapse;
}
th,td
{
padding:3px;
}
</style>

</head>

<body>
<h1>Joe Smith - Fab Academy 2024</h1>
<h2>Networking and communications</h2>

<h3>Week 13 Assignment</h3>
<p>
The assignment for this week is to design and build a wired &/or wireless network connecting at least two nodes. I decided to make a small network based upon a serial asynchronous bus.
</p>

<hr style="width:80%">
 
<h3>Bus bridge</h3>
<ol>
<li>I used Eagle CAD to create a modified version of the ATtiny45 based <b>hello.bus.45.bridge.cad</b> design and added a second LED.
</li>

<p>
<img src="bridge45sch.png"/>
</p>
<p>
<i>Eagle CAD schematic for bus.45.bridge</i>
</p>
<br>

<p>
<img src="bridge45.jpg"/>
</p>
<p>
<i>Completed bus.45.bridge circuit showing components and connections.</i>
</p>
<br>

</ol>
<h3>bus.45.bridge related files</h3>
<ul>
<li>
This is an example of unordered HTML list
</li>

<li>
<a href="bus.bridge.45.sz.with2leds.c" target="_blank">bus.bridge.45.sz.with2leds.c - AVR C program</a> 
</li>
<li>
There was no make file. I used Atmel Studio so F_CPU 8000000UL is defined in the program. I used the default fuse settings. 
</li>
</ul>

<hr style="width:80%">

<!--This is an example comment. It is not displayed by the browser-->  

<!--                         --> 
<!--         \|||/           --> 
<!--         (o o)           --> 
<!--------ooO-(_)-Ooo----------> 
<!--                         --> 
<!--    Killroy was here     --> 
<!--                         -->

<h3>Setting up the network</h3>
<ol>
<li>This is an example of an ordered HTML list
</li>
<br>
<li>
I then programmed the nodes one at a time by connecting them to the ISP and to the bridge node by the bus cable in order to receive power.
</li>
<br>
<li>
After all the nodes were programmed I put them on the network at the same time.
</li>
<br>
<li>
I first tried to communicate the with the nodes using term.py in Ubuntu 12.04 by using the command: <i>sudo python term.py /dev/ttyUSB0 9600</i>. The program term.py worked but all three nodes just sat there doing nothing.
</li>
<br>
<li>
I then tried it on my Windows 7 computer. Hyperterminal is no longer included with Windows 7 so I had to find it on the web and install it. I used Windows Device Manager to determine that the FTDI was connected to COM3. I then configured hyper terminal for COM3, 9600 bits per second, 8 data bits, no parity bits, 1 stop bit, and no flow control.
</li>
<br>
<li>
This time the green LEDs on all three nodes blinked each time I pressed a key on the keyboard. The node in the middle of the bus (ATtiny45 node) responded intermittently and sometimes the response was garbled. If I reset the power to the node sometimes it would work better sometimes it would work worse.
</li>
<br>
<li>
It seemed like a timing problem to me, so I looked into calibrating the clock. Atmel Studio has an option related to this. It said that the OSCCAL value for this chip at 8 MHz was 0x9D. However, I decided to first try to change the <b>bit_delay_time</b> value to 102 (it was initially 100). What a different this made. The node seems to work every time now and the responses are not garbled anymore.
</li>

<br>
<div style="background:#97e21f;color:black">
<strong>Commands to set fuses and download program to the circuit board.</strong><br>

<pre>
sudo avrdude -p t44 -P usb -c avrisp2 -U lfuse:w:0x5E:m

	avrdude: AVR device initialized and ready to accept instructions

	Reading | ################################################## | 100% 0.00s

	avrdude: Device signature = 0x1e9207
	avrdude: reading input file "0x5E"
	avrdude: writing lfuse (1 bytes):

	Writing | ################################################## | 100% 0.00s

	avrdude: 1 bytes of lfuse written
	avrdude: verifying lfuse memory against 0x5E:
	avrdude: input file 0x5E contains 1 bytes
	avrdude: reading on-chip lfuse data:

	Reading | ################################################## | 100% 0.00s

	avrdude: verifying ...
	avrdude: 1 bytes of lfuse verified

	avrdude: safemode: Fuses OK

	avrdude done.  Thank you.

sudo avrdude -p t44 -P usb -c avrisp2 -U flash:w:hello.ftdi.44.io.hex

	avrdude: AVR device initialized and ready to accept instructions

	Reading | ################################################## | 100% 0.00s

	avrdude: Device signature = 0x1e9207
	avrdude: NOTE: FLASH memory has been specified, an erase cycle will be performed
        	 To disable this feature, specify the -D option.
	avrdude: erasing chip
	avrdude: reading input file "hello.ftdi.44.io.hex"
	avrdude: input file hello.ftdi.44.io.hex auto detected as Intel Hex
	avrdude: writing flash (14 bytes):

	Writing | ################################################## | 100% 0.01s

	avrdude: 14 bytes of flash written
	avrdude: verifying flash memory against hello.ftdi.44.io.hex:
	avrdude: load data flash data from input file hello.ftdi.44.io.hex:
	avrdude: input file hello.ftdi.44.io.hex auto detected as Intel Hex
	avrdude: input file hello.ftdi.44.io.hex contains 14 bytes
	avrdude: reading on-chip flash data:

	Reading | ################################################## | 100% 0.01s

	avrdude: verifying ...
	avrdude: 14 bytes of flash verified

	avrdude: safemode: Fuses OK

	avrdude done.  Thank you.
</pre>
</div>

<li>
The bridge node was a different story. Although the green LED blinked to indicate it was receiving data, the red LED never blinked and the bridge node never displayed anything on hyperterminal.
</li>
<br>
<li>
Instead of only responding when receiving it's node ID, I edited the bridge program to echo back any data it received.  
</li>
<br>
<li>
I don't know if the data is garbled to the node, from the node, or both. However, it appeared that communications with the bridge node was not working well. The input data to the node was probably garbled to the point it did not match it's node ID, which would explain it not lighting the red LED or sending a message to hyperterm. Atmel Studio said that the OSCCAL value for this chip at 8 MHz was 0x58. I decided to first try to change the <b>bit_delay_time</b> value to 104 (it was initially 100). This solved the problem completely. This node also works every time now and the responses are not garbled anymore.
</li>
<br>
<li>
Here is the "serial asynchronous bus" in action. 
</li>
<ul>
<li>The three different nodes communicate with the PC using an FTDI cable. 
</li>
<li>After troubleshooting, I ended up changing the node IDs assigned to each device. Now the bridge node on the left is node ID 1, the middle node is node ID 2, and the node on the right is node ID 3.
</li>
<li>The nodes are controlled by typing number keys into hyper terminal.
</li>
<li>The green LED on each node flashes when it receives data over the bus.
</li>
<li>If the data character received matches a nodes "ID", it will respond by flashing its red LED and sending a text message to hyper terminal.
</li>
<li>The node on the right side also responds with the state of its push button. 
</li>
<li>
The node in the middle has a second condition programmed in. If it detects character 5, it responds by flashing both its green and red LEDs and send the text message "flash both".
</li>
<br>

<iframe width="420" height="345"
src="http://www.youtube.com/embed/vwr_hBivC6U">
</iframe>
<br>
<a href="http://www.youtube.com/watch?v=vwr_hBivC6U" target="_blank">Click this link if embedded video is not working</a> 

</ul>
</ol>
    
<hr style="width:80%">
    
<h3>This is an example of a table</h3>
<a>
    
 <table>
  <tr>
    <th>Name</th>
    <th>Phone Number</th>
    <th>Program</th>
  </tr>
  <tr>
    <td>Joe Smith</td>
    <td>440-366-7644</td>
    <td>Electronics</td>
  </tr>
  <tr>
    <td>Pam Jones</td>
    <td>440-543-7755</td>
    <td>Engineering</td>
  </tr>
  <tr>
    <td>Ron Jackson</td>
    <td>440-216-3476</td>
    <td>Math</td>
  </tr>
</table>   
    </a>
    
<br>

<hr style="width:80%">

<a href="index.html">Back to index</a>

</body>
</html> 